from Plasma import *
from PlasmaTypes import *
from PlasmaKITypes import *
import cPickle


class ptClimbingWallMsgState:


    def __init__(self):
        pass

    kWaiting = 0
    kNorthSit = 1
    kSouthSit = 2
    kNorthSelect = 3
    kSouthSelect = 4
    kNorthReady = 5
    kSouthReady = 6
    kNorthPlayerEntry = 7
    kSouthPlayerEntry = 8
    kNorthWin = 9
    kSouthWin = 10
    kNorthQuit = 11
    kSouthQuit = 12
    kGameInProgress = 13


## blockers activators on the panels
northPanelClick = ptAttribActivator(1, 'North Panel Clickables')
southPanelClick = ptAttribActivator(2, 'South Panel Clickables')
## blockers physics on both panels
northPanel = ptAttribSceneobjectList(3, 'North Panel Objects', byObject=1)
southPanel = ptAttribSceneobjectList(4, 'South Panel Objects', byObject=1)
## blockers physicals on the Wall (remember: the SOUTH blockers are of course on the NORTH wall and vice-versa)
northWall = ptAttribSceneobjectList(5, 'North Wall', byObject=1)
southWall = ptAttribSceneobjectList(6, 'South Wall', byObject=1)
## chair clickable (to init game)
northChair = ptAttribActivator(7, 'North Chair')
southChair = ptAttribActivator(8, 'South Chair')
## blockers drawed on the panel
northLights = ptAttribSceneobjectList(9, 'North Panel Lights', byObject=1)
southLights = ptAttribSceneobjectList(10, 'South Panel Lights', byObject=1)
## blocker counters decals on the panels
northCountLights = ptAttribSceneobjectList(11, 'North Count Lights', byObject=1)
southCountLights = ptAttribSceneobjectList(12, 'South Count Lights', byObject=1)
## south panel blocker count buttons
upButtonS = ptAttribActivator(13, 'S up count button')
dnButtonS = ptAttribActivator(14, 'S down count button')
readyButtonS = ptAttribActivator(15, 'S ready button')
## north panel blocker count buttons
upButtonN = ptAttribActivator(18, 'N up count button')
dnButtonN = ptAttribActivator(19, 'N down count button')
readyButtonN = ptAttribActivator(20, 'N ready button')
## open tube/reset/turn on Wall
goButtonN = ptAttribActivator(21, 'N Go Button activator')
goButtonS = ptAttribActivator(22, 'S Go Button activator')
## layer anim for big buttons responders
#goBtnNResp = ptAttribResponder(23, 'N Go Button anim responder', ["unknown", "bright", "dim", "pulse"], netForce=0) # "unknown" is the default layer anim. I don't know what it is, I didn't test it.
#goBtnSResp = ptAttribResponder(24, 'S Go Button anim responder', ["unknown", "bright", "dim", "pulse"], netForce=0)
## SittingModifier (notify when we exit the chair)
nChairSit = ptAttribActivator(25, 'N sit component')
sChairSit = ptAttribActivator(26, 'S sit component')
## north panel blocker preset buttons
fiveBtnN = ptAttribActivator(27, '5 btn N')
tenBtnN = ptAttribActivator(28, '10 btn N')
fifteenBtnN = ptAttribActivator(29, '15 btn N')
## south panel blocker preset buttons
fiveBtnS = ptAttribActivator(30, '5 btn S')
tenBtnS = ptAttribActivator(31, '10 btn S')
fifteenBtnS = ptAttribActivator(32, '15 btn S')
## open tubes responders
sTubeOpen = ptAttribNamedResponder(33, 'S tube open', netForce=0)
nTubeOpen = ptAttribNamedResponder(34, 'N tube open', netForce=0)
## close tubes responders
sTubeClose = ptAttribNamedResponder(35, 'S tube close', netForce=0)
nTubeClose = ptAttribNamedResponder(36, 'N tube close', netForce=0)
## logic modifier for avatar dectect in the tube
sTubeEntry = ptAttribNamedActivator(37, 'S tube entry trigger')
nTubeEntry = ptAttribNamedActivator(38, 'N tube entry trigger')
## MultistageBehavior to animate avatar in tube
sTubeMulti = ptAttribBehavior(43, 's tube entry multi', netForce=0)
nTubeMulti = ptAttribBehavior(44, 'n tube entry multi', netForce=0)
## tube exclude regions
sTubeExclude = ptAttribExcludeRegion(45, 's tube exclude')
nTubeExclude = ptAttribExcludeRegion(46, 'n tube exclude')
## warp points to Wall area
nTeamWarpPt = ptAttribSceneobject(47, 'n team warp point')
sTeamWarpPt = ptAttribSceneobject(48, 's team warp point')
## top wall win region
sTeamWin = ptAttribActivator(49, 's team win')
nTeamWin = ptAttribActivator(50, 'n team win')
## quit activators
sTeamQuit = ptAttribActivator(51, 's team quit')
nTeamQuit = ptAttribActivator(52, 'n team quit')
## quit wps
sTeamWinTeleport = ptAttribSceneobject(53, 's team win point')
nTeamWinTeleport = ptAttribSceneobject(54, 'n team win point')
## smartseek and anim before link
nQuitBehavior = ptAttribBehavior(55, 's quit behavior', netForce=0)
sQuitBehavior = ptAttribBehavior(56, 'n quit behavior', netForce=0)
## sfx responders
# I know it would be better if netForce was 0, but it would be too complicated in OnNotify (these don't send a lot of messages anyway)
nPanelSound = ptAttribResponder(57, 'n panel sound', ['main', 'up', 'down', 'select', 'blockerOn', 'blockerOff', 'gameStart', 'denied'], netForce=1)
sPanelSound = ptAttribResponder(58, 's panel sound', ['main', 'up', 'down', 'select', 'blockerOn', 'blockerOff', 'gameStart', 'denied'], netForce=1)


## for team light responders (count). The first two are also used for blockers (on/off)
kTeamLightsOn = 0
kTeamLightsOff = 1
kRedOn = 3
kRedOff = 4
kRedFlash = 2
##

## for go button light states (doesn't work on MOUL)
kDim = 0 # desactivated
kBright = 1 # can be pushed
kPulse = 2 # has to be pushed

## current game state (assuming Wall off, if there is a game running it will be updated in OnServerInitComplete)
SouthState = ptClimbingWallMsgState.kWaiting
NorthState = ptClimbingWallMsgState.kWaiting
## current blockers set and max number
NorthCount = 0
SouthCount = 0
BlockerCountLimit = 0
## sets which blocker (from 0 to 171) is set for each of the panels
NorthWall = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1]
SouthWall = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1]
## accessories avatar can be wearing (these shouldn't be added to the Relto closet in MOULa, change the code if you need to)
MaleSuit = ['03_MHAcc_SuitHelmet', '03_MLHand_Suit', '03_MRHand_Suit', '03_MTorso_Suit', '03_MLegs_Suit', '03_MLFoot_Suit', '03_MRFoot_Suit']
FemaleSuit = ['03_FHair_SuitHelmet', '03_FLHand_Suit', '03_FRHand_Suit', '03_FTorso_Suit', '03_FLegs_Suit', '03_FLFoot_Suit', '03_FRFoot_Suit']

class grsnWallPython(ptResponder):
#Gahreesen Wall, MOUL version (using SDLs instead of ptClimbingWallMsg)
# works finally fine (hope so)

    def __init__(self):
        PtDebugPrint('grsnWallPython::__init__')
        ptResponder.__init__(self)
        self.id = 52392
        self.version = 3


    def OnFirstUpdate(self): # make sure other scripts won't receive sdl notifies.
        ageSDL = PtGetAgeSDL()
        if (not (len(PtGetPlayerList()))):
            ageSDL["nChairState"] = (0,)
            ageSDL["sChairState"] = (0,)
            ageSDL["northWall"] = (-1,)*20
            ageSDL["southWall"] = (-1,)*20
            ageSDL["blockerCountLimit"] = (0,)


    def OnServerInitComplete(self):
        '''Tells what to do on link-in'''
        global ReceiveInit
        global BlockerCountLimit
        global SouthWall
        global NorthWall
        global NorthCount
        global SouthCount
        global SouthState
        global NorthState
        PtDebugPrint('grsnWallPython::OnServerInitComplete')
        ageSDL = PtGetAgeSDL()
        if len(PtGetPlayerList()): # if there is someone in the Age already we need to know the Wall current state
            print 'game running already -> requesting game state'
            NorthState = ageSDL["nChairState"][0]
            SouthState = ageSDL["sChairState"][0]
            BlockerCountLimit = ageSDL["blockerCountLimit"][0]

            for blocker in ageSDL["northWall"]:
                if blocker >= 0:
                    self.SetWallIndex(blocker, true, true) # this updates NorthWall and NorthCount for us
                    self.ChangeNorthBlocker(blocker)
            for blocker in ageSDL["southWall"]:
                if blocker >= 0:
                    self.SetWallIndex(blocker, true, false) # this updates SouthWall and SouthCount for us
                    self.ChangeSouthBlocker(blocker)


            ### synchronise client with current game state ###
            # north
            if (NorthState == ptClimbingWallMsgState.kWaiting):
                self.SetNPanelMode(ptClimbingWallMsgState.kWaiting)
            elif (NorthState == ptClimbingWallMsgState.kNorthSit):
                self.SetNPanelMode(ptClimbingWallMsgState.kWaiting)
                #goBtnNResp.run(self.key, state="bright", fastforward=1)
            elif (NorthState == ptClimbingWallMsgState.kNorthSelect):
                nTubeExclude.clear(self.key)
                nTubeClose.run(self.key, fastforward=1)
                self.EnableNorthButtons(true)
                self.UpdateBlockerCountDisplay()
                #goBtnNResp.run(self.key, state="dim", fastforward=1)
                nPanelSound.run(self.key, state='main', netForce=0, netPropagate=0, fastforward=1)
            elif (NorthState == ptClimbingWallMsgState.kNorthReady):
                i = BlockerCountLimit
                while ((i < 20)):
                    northCountLights.value[i].runAttachedResponder(kRedOn)
                    i = (i + 1)
                nTubeExclude.clear(self.key)
                nTubeClose.run(self.key, fastforward=1)
                self.EnableNorthButtons(true)
                upButtonN.disable()
                dnButtonN.disable()
                readyButtonN.disable()
                fiveBtnN.disable()
                tenBtnN.disable()
                fifteenBtnN.disable()
                #goBtnNResp.run(self.key, state="pulse", fastforward=1)
            elif (NorthState == ptClimbingWallMsgState.kNorthPlayerEntry):
                i = BlockerCountLimit
                while ((i < 20)):
                    northCountLights.value[i].runAttachedResponder(kRedOn)
                    i = (i + 1)
                self.EnableNorthButtons(false)
                #goBtnNResp.run(self.key, state="dim", fastforward=1)
                if (SouthState == ptClimbingWallMsgState.kSouthPlayerEntry):
                    sTubeExclude.release(self.key)
                    sTubeEntry.enable()
                    sTubeOpen.run(self.key, fastforward=1) # fastforward will cause it not to notify the script, which means we must clear region as well
                    nTubeExclude.release(self.key)
                    nTubeEntry.enable()
                    nTubeOpen.run(self.key, fastforward=1)
            elif ((NorthState == ptClimbingWallMsgState.kNorthWin) or (NorthState == ptClimbingWallMsgState.kNorthQuit)):
                self.EnableNorthButtons(false)
                i = BlockerCountLimit
                while ((i < 20)):
                    northCountLights.value[i].runAttachedResponder(kRedOn)
                    i = (i + 1)
                nTubeExclude.clear(self.key)
                nTubeClose.run(self.key, fastforward=1)
            # south
            if (SouthState == ptClimbingWallMsgState.kWaiting):
                self.SetSPanelMode(ptClimbingWallMsgState.kWaiting)
            elif (SouthState == ptClimbingWallMsgState.kSouthSit):
                self.SetSPanelMode(ptClimbingWallMsgState.kWaiting)
                #goBtnSResp.run(self.key, state="bright", fastforward=1)
            elif (SouthState == ptClimbingWallMsgState.kSouthSelect):
                sTubeExclude.clear(self.key)
                sTubeClose.run(self.key, fastforward=1)
                self.EnableSouthButtons(true)
                self.UpdateBlockerCountDisplay()
                #goBtnSResp.run(self.key, state="dim", fastforward=1)
                sPanelSound.run(self.key, state='main', netForce=0, netPropagate=0, fastforward=1)
            elif (SouthState == ptClimbingWallMsgState.kSouthReady):
                i = BlockerCountLimit
                while ((i < 20)):
                    southCountLights.value[i].runAttachedResponder(kRedOn)
                    i = (i + 1)
                sTubeExclude.clear(self.key)
                sTubeClose.run(self.key, fastforward=1)
                self.EnableSouthButtons(true)
                upButtonS.disable()
                dnButtonS.disable()
                readyButtonS.disable()
                fiveBtnS.disable()
                tenBtnS.disable()
                fifteenBtnS.disable()
                #goBtnSResp.run(self.key, state="pulse", fastforward=1)
            elif (SouthState == ptClimbingWallMsgState.kSouthPlayerEntry):
                i = BlockerCountLimit
                while ((i < 20)):
                    southCountLights.value[i].runAttachedResponder(kRedOn)
                    i = (i + 1)
                self.EnableSouthButtons(false)
                #goBtnSResp.run(self.key, state="dim", fastforward=1)
                # in case we need to open the tubes, this has been done when checking north side already
            elif ((SouthState == ptClimbingWallMsgState.kSouthWin) or (SouthState == ptClimbingWallMsgState.kSouthQuit)):
                i = BlockerCountLimit
                while ((i < 20)):
                    southCountLights.value[i].runAttachedResponder(kRedOn)
                    i = (i + 1)
                self.EnableSouthButtons(false)
                sTubeExclude.clear(self.key)
                sTubeClose.run(self.key, fastforward=1)
        else:
            print 'solo in climbing wall -> no need to ask game state.'
            self.SetNPanelMode(ptClimbingWallMsgState.kWaiting)
            self.SetSPanelMode(ptClimbingWallMsgState.kWaiting)
        ageSDL.setFlags('lastChangedIndexN', 0, 1)# variables to be notified about
        ageSDL.setNotify(self.key, 'lastChangedIndexN', 0.0)
        ageSDL.sendToClients('lastChangedIndexN')
        ageSDL.setFlags('lastChangedIndexS', 0, 1)
        ageSDL.setNotify(self.key, 'lastChangedIndexS', 0.0)
        ageSDL.sendToClients('lastChangedIndexS')
        ageSDL.setFlags('nChairState', 0, 1)
        ageSDL.setNotify(self.key, 'nChairState', 0.0)
        ageSDL.sendToClients('nChairState')
        ageSDL.setFlags('sChairState', 0, 1)
        ageSDL.setNotify(self.key, 'sChairState', 0.0)
        ageSDL.sendToClients('sChairState')
        ageSDL.setFlags('blockerCountLimit', 0, 1)
        ageSDL.setNotify(self.key, 'blockerCountLimit', 0.0)
        ageSDL.sendToClients('blockerCountLimit')


    def OnSDLNotify(self, VARname, SDLname, playerID, tag):
        global NorthState
        global SouthState
        global NorthWall
        global SouthWall
        global BlockerCountLimit
        ageSDL = PtGetAgeSDL()
        if VARname == "nChairState":
            NorthState = ageSDL["nChairState"][0]
            self.SetNPanelMode(NorthState)
        elif VARname == "sChairState":
            SouthState = ageSDL["sChairState"][0]
            self.SetSPanelMode(SouthState)
        elif ((NorthState == ptClimbingWallMsgState.kWaiting) or (SouthState == ptClimbingWallMsgState.kWaiting)):
            return ## uglyhack: in case we receive a SDL var change meant to RE-INIT vars (which would only cause troubles)
        elif VARname == "blockerCountLimit":
            BlockerCountLimit = ageSDL["blockerCountLimit"][0]
            self.UpdateBlockerCountDisplay()
        elif VARname == "lastChangedIndexN":
            blocker = ageSDL["lastChangedIndexN"][0]
            on = ageSDL["lastChangedIndexN"][1]
            self.SetWallIndex(blocker, on, true)
            self.ChangeNorthBlocker(blocker)
        elif VARname == "lastChangedIndexS":
            blocker = ageSDL["lastChangedIndexS"][0]
            on = ageSDL["lastChangedIndexS"][1]
            self.SetWallIndex(blocker, on, false)
            self.ChangeSouthBlocker(blocker)


    def SetSPanelMode(self, state):
        '''Update panel with specified state'''
        global BlockerCountLimit
        global NorthState
        print 'set S Panel Mode called with state ',
        print state
        if (state == ptClimbingWallMsgState.kWaiting): # now used on server init complete only
            self.EnableSouthButtons(false)
            sTubeExclude.clear(self.key)
            sTubeClose.run(self.key, fastforward=1)
            #goBtnSResp.run(self.key, avatar=PtGetLocalAvatar(), state="dim")
        elif (state == ptClimbingWallMsgState.kSouthSit):
            pass
            #goBtnSResp.run(self.key, avatar=PtGetLocalAvatar(), state="bright")
        elif (state == ptClimbingWallMsgState.kSouthSelect):
            self.ResetSouthPanel()
            print 'enabled all s switches'
        elif (state == ptClimbingWallMsgState.kSouthReady):
            i = 0
            while ((i < BlockerCountLimit)):
                southCountLights.value[i].runAttachedResponder(kTeamLightsOff)
                i = (i + 1)
            i = BlockerCountLimit
            while ((i < 20)):
                southCountLights.value[i].runAttachedResponder(kRedOn)
                i = (i + 1)
            upButtonS.disable()
            dnButtonS.disable()
            readyButtonS.disable()
            fiveBtnS.disable()
            tenBtnS.disable()
            fifteenBtnS.disable()
            #goBtnSResp.run(self.key, avatar=PtGetLocalAvatar(), state="pulse")
        elif (state == ptClimbingWallMsgState.kSouthPlayerEntry):
            self.EnableSouthButtons(false)
            #goBtnSResp.run(self.key, avatar=PtGetLocalAvatar(), state="dim")
            if (NorthState == ptClimbingWallMsgState.kNorthPlayerEntry):
                # other side was waiting for us, so WE have to update the tubes
                sTubeOpen.run(self.key)
                nTubeOpen.run(self.key)
                print 'tubes open'
        elif ((state == ptClimbingWallMsgState.kNorthQuit) or ((state == ptClimbingWallMsgState.kNorthWin) or ((state == ptClimbingWallMsgState.kSouthQuit) or (state == ptClimbingWallMsgState.kSouthWin)))):
            sTubeExclude.clear(self.key)
            sTubeClose.run(self.key)


    def SetNPanelMode(self, state):
        '''Update panel with specified state'''
        global BlockerCountLimit
        global SouthState
        print 'set N Panel Mode called with state ',
        print state
        if (state == ptClimbingWallMsgState.kWaiting): # serverinitcomplete
            self.EnableNorthButtons(false)
            nTubeExclude.clear(self.key)
            nTubeClose.run(self.key, fastforward=1)
            #goBtnNResp.run(self.key, avatar=PtGetLocalAvatar(), state="dim")
        elif (state == ptClimbingWallMsgState.kNorthSit):
            pass
            #goBtnNResp.run(self.key, avatar=PtGetLocalAvatar(), state="bright")
        elif (state == ptClimbingWallMsgState.kNorthSelect):
            self.ResetNorthPanel()
            print 'enabled all n switches'
        elif (state == ptClimbingWallMsgState.kNorthReady):
            i = 0
            while ((i < BlockerCountLimit)):
                northCountLights.value[i].runAttachedResponder(kTeamLightsOff)
                i = (i + 1)
            i = BlockerCountLimit
            while ((i < 20)):
                northCountLights.value[i].runAttachedResponder(kRedOn)
                i = (i + 1)
            upButtonN.disable()
            dnButtonN.disable()
            readyButtonN.disable()
            fiveBtnN.disable()
            tenBtnN.disable()
            fifteenBtnN.disable()
            #goBtnNResp.run(self.key, avatar=PtGetLocalAvatar(), state="pulse")
        elif (state == ptClimbingWallMsgState.kNorthPlayerEntry):
            self.EnableNorthButtons(false)
            #goBtnNResp.run(self.key, avatar=PtGetLocalAvatar(), state="dim")
            if (SouthState == ptClimbingWallMsgState.kSouthPlayerEntry):
                sTubeOpen.run(self.key)
                nTubeOpen.run(self.key)
                print 'tubes open'
        elif ((state == ptClimbingWallMsgState.kNorthQuit) or ((state == ptClimbingWallMsgState.kNorthWin) or ((state == ptClimbingWallMsgState.kSouthQuit) or (state == ptClimbingWallMsgState.kSouthWin)))):
            nTubeExclude.clear(self.key)
            nTubeClose.run(self.key)


    def ResetNorthPanel(self):
        '''Reset responders and values when restarting game'''
        global NorthCount
        global BlockerCountLimit
        self.EnableNorthButtons(true)
        self.ClearIndices(true)
        if (BlockerCountLimit > 0): ### zeroblockercount fails here sending the variable -somehow- so I've moved it in onnotify
            self.ZeroBlockerCount() # maybe ptSDL doesn't like sending too many variables at once ?
        self.UpdateBlockerCountDisplay()
        #goBtnNResp.run(self.key, avatar=PtGetLocalAvatar(), state="dim")


    def ResetSouthPanel(self):
        '''Reset responders and values when restarting game'''
        global SouthCount
        global BlockerCountLimit
        self.EnableSouthButtons(true)
        self.ClearIndices(false)
        if (BlockerCountLimit > 0): ### zeroblockercount fails here sending the variable -somehow- so I've moved it in onnotify
            self.ZeroBlockerCount()
        self.UpdateBlockerCountDisplay()
        #goBtnSResp.run(self.key, avatar=PtGetLocalAvatar(), state="dim")


    def ClearIndices(self, north):
        '''Clear set blockers, and run "off" layer anim'''
        global NorthWall
        global SouthWall
        global NorthCount
        global SouthCount
        ageSDL = PtGetAgeSDL()
        i = 0
        while ((i < 171)):
            if (i < 20):
                # clear set blocker
                if north:
                    NorthWall[i] = -1
                else:
                    SouthWall[i] = -1
            # run all the layer anims on the panel
            if north:
                northLights.value[i].runAttachedResponder(kTeamLightsOff)
                northWall.value[i].physics.suppress(true) # fix bug reported by D'Lanor
            else:
                southLights.value[i].runAttachedResponder(kTeamLightsOff)
                southWall.value[i].physics.suppress(true) # fix bug reported by D'Lanor
            i = (i + 1)
        if north:
            NorthCount = 0
            if (ageSDL["northWall"] != (-1,)*20):
                ageSDL["northWall"] = (-1,)*20
        else:
            SouthCount = 0
            if (ageSDL["southWall"] != (-1,)*20):
                ageSDL["southWall"] = (-1,)*20


    def EnableSouthButtons(self, enable):
        '''Enable or not the south buttons physics'''
        i = 0
        while ((i < 171)):
            if enable:
                southPanel.value[i].physics.suppress(false)
            else:
                southPanel.value[i].physics.suppress(true)
            i = (i + 1)
        if enable:
            upButtonS.enable()
            dnButtonS.enable()
            readyButtonS.enable()
            fiveBtnS.enable()
            tenBtnS.enable()
            fifteenBtnS.enable()
        else:
            upButtonS.disable()
            dnButtonS.disable()
            readyButtonS.disable()
            fiveBtnS.disable()
            tenBtnS.disable()
            fifteenBtnS.disable()


    def EnableNorthButtons(self, enable):
        '''Enable or not the north buttons physics'''
        i = 0
        while ((i < 171)):
            if enable:
                northPanel.value[i].physics.suppress(false)
            else:
                northPanel.value[i].physics.suppress(true)
            i = (i + 1)
        if enable:
            upButtonN.enable()
            dnButtonN.enable()
            readyButtonN.enable()
            fiveBtnN.enable()
            tenBtnN.enable()
            fifteenBtnN.enable()
        else:
            upButtonN.disable()
            dnButtonN.disable()
            readyButtonN.disable()
            fiveBtnN.disable()
            tenBtnN.disable()
            fifteenBtnN.disable()


    def LookupIndex(self, index, north):
        '''Returns whether blocker is on or not'''
        global BlockerCountLimit
        global NorthWall
        global SouthWall
        i = 0
        print 'looking north ',
        print north
        if north:
            while ((i < BlockerCountLimit)):
                if (NorthWall[i] == index):
                    print 'index found in north list in slot ',
                    print i
                    return true
                print 'north wall [',
                print i,
                print '] = ',
                print NorthWall[i]
                i = (i + 1)
        else:
            while ((i < BlockerCountLimit)):
                if (SouthWall[i] == index):
                    print 'index found in south list in slot ',
                    print i
                    return true
                print 'south wall [',
                print i,
                print '] = ',
                print SouthWall[i]
                i = (i + 1)
        print 'index not found'
        return false


    def SetWallIndex(self, index, value, north):
        '''Raise or not one of the blockers'''
        global NorthWall
        global NorthCount
        global SouthWall
        global SouthCount
        i = 0
        if value:
            if north:
                while ((NorthWall[i] >= 0)):
                    i = (i + 1)
                    if (i == 20):
                        print 'yikes - somehow overran the array!'
                        return
                NorthWall[i] = index
                NorthCount = (NorthCount + 1)
                print 'set north wall index ',
                print index,
                print ' in slot ',
                print i,
                print ' to true'
            else:
                while ((SouthWall[i] >= 0)):
                    i = (i + 1)
                    if (i == 20):
                        print 'yikes - somehow overran the array!'
                        return
                SouthWall[i] = index
                SouthCount = (SouthCount + 1)
                print 'set south wall index ',
                print index,
                print ' in slot ',
                print i,
                print ' to true'
        elif north:
            while ((NorthWall[i] != index)):
                i = (i + 1)
                if (i == 20):
                    print 'this should not get hit - looked for non-existent NorthWall entry!'
                    return
            NorthWall[i] = -1
            NorthCount = (NorthCount - 1)
            print 'removed index ',
            print index,
            print ' from list slot ',
            print i
        else:
            while ((SouthWall[i] != index)):
                i = (i + 1)
                if (i == 20):
                    print 'this should not get hit - looked for non-existent SouthWall entry!'
                    return
            SouthWall[i] = -1
            SouthCount = (SouthCount - 1)
            print 'removed index ',
            print index,
            print ' from list slot ',
            print i


    def ChangeSouthBlocker(self, index):
        '''Sets the south blocker index the inverse of its current state'''
        global SouthCount
        print 'found South index ',
        print index
        wallPicked = southWall.value[index]
        animPicked = southLights.value[index]
        if self.LookupIndex(index, false):
            wallPicked.physics.suppress(false)
            animPicked.runAttachedResponder(kTeamLightsOn)
            counterPicked = southCountLights.value[(SouthCount - 1)]
            counterPicked.runAttachedResponder(kTeamLightsOn)
            sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='blockerOn')
        else:
            wallPicked.physics.suppress(true)
            animPicked.runAttachedResponder(kTeamLightsOff)
            counterPicked = southCountLights.value[SouthCount]
            counterPicked.runAttachedResponder(kTeamLightsOff)
            sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='blockerOff')
        return


    def ChangeNorthBlocker(self, index):
        '''Sets the north blocker index the inverse of its current state'''
        global NorthCount
        print 'found North index ',
        print index
        wallPicked = northWall.value[index]
        animPicked = northLights.value[index]
        if self.LookupIndex(index, true):
            wallPicked.physics.suppress(false)
            animPicked.runAttachedResponder(kTeamLightsOn)
            counterPicked = northCountLights.value[(NorthCount - 1)]
            counterPicked.runAttachedResponder(kTeamLightsOn)
            nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='blockerOn')
        else:
            wallPicked.physics.suppress(true)
            animPicked.runAttachedResponder(kTeamLightsOff)
            counterPicked = northCountLights.value[NorthCount]
            counterPicked.runAttachedResponder(kTeamLightsOff)
            nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='blockerOff')
        return


    def ChangeGameState(self, newState):
        '''Send new state to the game'''
        print 'sending change game state message with state ',
        print newState
        sdl = PtGetAgeSDL()
        if (newState/2 == newState/2.): # newState/2 is always an int for South (originally it wasn't, but I modified it slightly to make it so.)
            sdl["sChairState"] = (newState,)
        elif (newState != ptClimbingWallMsgState.kWaiting) and (newState != ptClimbingWallMsgState.kGameInProgress):
            sdl["nChairState"] = (newState,)
        else: ## this is not used in the current script
            sdl["nChairState"] = (newState,)
            sdl["sChairState"] = (newState,)


    def ChangeBlockerCount(self, newCount):
        '''Send number of blockers to game'''
        print 'sending change blocker count message with new count ',
        print newCount
        sdl = PtGetAgeSDL()
        sdl["blockerCountLimit"] = (newCount,)


    def ChangeBlockerState(self, on, index, north): # had to hack it a bit to use SDLs, should finally work fine
        '''Tell the game to remove or add blocker'''
        sdl = PtGetAgeSDL()
        ## note: we need to use a buffer var instead of using sdl[varname][index] = value.
        #  ptAgeSDL stores variables in a tuple, not a list
        if north: buf = list(NorthWall)
        else: buf = list(SouthWall)
        i = 0
        while i < 20:
            if on:
                if buf[i] == -1:
                    buf[i] = index
                    break
            else:
                if buf[i] == index:
                    buf[i] = -1
                    break
            i += 1
        if north: sdl["northWall"] = tuple(buf) ### we update this var even if other scripts aren't notified of it BECAUSE player linking-in will need it
        else: sdl["southWall"] = tuple(buf)
        if north:
            sdl["lastChangedIndexN"] = (index, on)
        else:
            sdl["lastChangedIndexS"] = (index, on)


    def UpdateBlockerCountDisplay(self):
        '''Sets the panels lights'''
        global BlockerCountLimit
        numSelected = BlockerCountLimit
        i = 0
        while ((i < numSelected)):
            northCountLights.value[i].runAttachedResponder(kTeamLightsOn)
            southCountLights.value[i].runAttachedResponder(kTeamLightsOn)
            i = (i + 1)
        i = numSelected
        while ((i < 20)):
            northCountLights.value[i].runAttachedResponder(kRedFlash)
            southCountLights.value[i].runAttachedResponder(kRedFlash)
            i = (i + 1)


    def IAmMaster(self):
        '''Tells if we're the game master'''
        return self.sceneobject.isLocallyOwned()


    def ZeroBlockerCount(self): # same as ChangeBlockerCount(0). It was used to send another parameter we don't need anymore
        '''Reset max number of blockers'''
        sdl = PtGetAgeSDL()
        sdl["blockerCountLimit"] = (0,)


    def OnTimer(self, id):
        '''Run callback actions'''
        avatar = PtGetLocalAvatar()
        if (id == ptClimbingWallMsgState.kNorthQuit):
            PtFakeLinkAvatarToObject(avatar.getKey(), sTeamWinTeleport.value.getKey())
            self.ChangeGameState(ptClimbingWallMsgState.kNorthQuit)
            self.ChangeGameState(ptClimbingWallMsgState.kSouthWin)
        else:
            PtFakeLinkAvatarToObject(avatar.getKey(), nTeamWinTeleport.value.getKey())
            self.ChangeGameState(ptClimbingWallMsgState.kNorthWin)
            self.ChangeGameState(ptClimbingWallMsgState.kSouthQuit)


    def SetWearingMaintainerSuit(self, avatar):
        '''Sets the avatar wearing a maintainer's suit, if that's not already the case'''
        currentgender = avatar.avatar.getAvatarClothingGroup()
        # get the gender of our avatar
        if (currentgender == kFemaleClothingGroup):
            clothing = FemaleSuit
        else:
            clothing = MaleSuit

        """
        In MOUL, we don't want to add this item to the Closet. Change the code if you want it.
        I'm not sure MOUL's Relto closet can handle the Suit. Has to be checked before enabling.
        Anyway, PtWearMaintainerSuit was not removed
        
        if (not (self.IItemInCloset(avatar, clothing[0]))):"""
        if False:
            # we don't have the suit in our Relto, so let's add it.
            avatar.avatar.addWardrobeClothingItem(clothing[0], ptColor().white(), ptColor().white())
            print "grsnWallPython: added the suit to your wardrobe"

        # check the clothing our avatar is wearing
        worn = avatar.avatar.getAvatarClothingList()
        for item in worn:
            name = item[0]
            if (name in clothing):
                print "Avatar seems to be wearing the suit already."
                return

        # give the avatar his suit.
        PtWearMaintainerSuit(avatar.getKey(), true)
        print "grsnWallPython: avatar is now wearing suit."


    def IItemInCloset(self, avatar, clothingName):
        '''Returns whether the avatar already owns an item'''
        clothingList = avatar.avatar.getWardrobeClothingList()
        for item in clothingList:
            if (clothingName == item[0]):
                return 1
        return 0


    def OnNotify(self, state, id, events):
        '''Manages notifies from objects and responders'''
        global SouthState
        global NorthState
        global BlockerCountLimit
        global SouthCount
        global NorthCount
        avatar = PtFindAvatar(events)
        southState = SouthState
        northState = NorthState
        print 'southState = ',
        print southState
        print 'northState = ',
        print northState
        if (id == sQuitBehavior.id):
            for event in events:
                if ((event[0] == kMultiStageEvent) and ((event[1] == 0) and (event[2] == kEnterStage))):
                    print 'start touching quit jewel, warp out'
                    if (avatar == PtGetLocalAvatar()):
                        PtAtTimeCallback(self.key, 0.80000000000000004, ptClimbingWallMsgState.kSouthQuit)
                    return
        if (id == nQuitBehavior.id):
            for event in events:
                if ((event[0] == kMultiStageEvent) and ((event[1] == 0) and (event[2] == kEnterStage))):
                    print 'start touching quit jewel, warp out'
                    if (avatar == PtGetLocalAvatar()):
                        PtAtTimeCallback(self.key, 0.80000000000000004, ptClimbingWallMsgState.kNorthQuit)
                    return
        if (id == nTubeOpen.id):
            print 'tube finished opening'
            nTubeExclude.release(self.key)
            nTubeEntry.enable()
        if (id == nTubeMulti.id):
            for event in events:
                if ((event[0] == kMultiStageEvent) and ((event[1] == 0) and (event[2] == kEnterStage))):
                    print 'Smart seek completed. close tube'
                    nTubeExclude.clear(self.key)
                    nTubeClose.run(self.key, avatar=avatar)
                elif ((event[0] == kMultiStageEvent) and ((event[1] == 0) and (event[2] == kAdvanceNextStage))):
                    print 'multistage complete, warp to wall south room with suit'
                    if (avatar == PtGetLocalAvatar()):
                        self.SetWearingMaintainerSuit(avatar)
                        PtSendKIMessage(kDisableEntireYeeshaBook, 0)
                    avatar.physics.warpObj(nTeamWarpPt.value.getKey())
                    nTubeOpen.run(self.key, avatar=avatar)
        if (id == sTubeOpen.id):
            print 'tube finished opening'
            sTubeExclude.release(self.key)
            sTubeEntry.enable()
        if (id == sTubeMulti.id):
            for event in events:
                if ((event[0] == kMultiStageEvent) and ((event[1] == 0) and (event[2] == kEnterStage))):
                    print 'Smart seek completed. close tube'
                    sTubeExclude.clear(self.key)
                    sTubeClose.run(self.key, avatar=avatar)
                elif ((event[0] == kMultiStageEvent) and ((event[1] == 0) and (event[2] == kAdvanceNextStage))):
                    print 'multistage complete, warp to wall north room with suit'
                    if (avatar == PtGetLocalAvatar()):
                        self.SetWearingMaintainerSuit(avatar)
                        PtSendKIMessage(kDisableEntireYeeshaBook, 0)
                    avatar.physics.warpObj(sTeamWarpPt.value.getKey())
                    sTubeOpen.run(self.key, avatar=avatar)
        if ((id == sTeamWin.id) and state):
            if (avatar == PtGetLocalAvatar()):
                print 'you win'
                PtFakeLinkAvatarToObject(avatar.getKey(), sTeamWinTeleport.value.getKey())
                self.ChangeGameState(ptClimbingWallMsgState.kSouthWin)
                self.ChangeGameState(ptClimbingWallMsgState.kNorthQuit)
        if ((id == nTeamWin.id) and state):
            if (avatar == PtGetLocalAvatar()):
                print 'you win'
                PtFakeLinkAvatarToObject(avatar.getKey(), nTeamWinTeleport.value.getKey())
                self.ChangeGameState(ptClimbingWallMsgState.kNorthWin)
                self.ChangeGameState(ptClimbingWallMsgState.kSouthQuit)
        if ((id == nTeamQuit.id) and state):
            avatar.avatar.runBehaviorSetNotify(nQuitBehavior.value, self.key, nQuitBehavior.netForce)
            return
        if ((id == sTeamQuit.id) and state):
            avatar.avatar.runBehaviorSetNotify(sQuitBehavior.value, self.key, sQuitBehavior.netForce)
            return
        if (id == southChair.id):
            print 'clicked south chair'
            if (avatar == PtGetLocalAvatar()):
                if state:
                    print 'sitting down in south chair'
                    southChair.disable()
                    if ((southState == ptClimbingWallMsgState.kWaiting) or ((southState == ptClimbingWallMsgState.kSouthWin) or (southState == ptClimbingWallMsgState.kSouthQuit))):
                        self.ChangeGameState(ptClimbingWallMsgState.kSouthSit)
                    return
        if (id == sChairSit.id):
            for event in events:
                if ((event[0] == 6) and ((event[1] == 1) and (state == 0))):
                    print 'standing up from south chair'
                    southChair.enable()
                    return
        if (id == northChair.id):
            print 'clicked north chair'
            if (avatar == PtGetLocalAvatar()):
                if state:
                    print 'sitting down in north chair'
                    northChair.disable()
                    if ((northState == ptClimbingWallMsgState.kWaiting) or ((northState == ptClimbingWallMsgState.kNorthWin) or (northState == ptClimbingWallMsgState.kNorthQuit))):
                        self.ChangeGameState(ptClimbingWallMsgState.kNorthSit)
                    return
        if (id == nChairSit.id):
            for event in events:
                if ((event[0] == 6) and ((event[1] == 1) and (state == 0))):
                    print 'standing up from north chair'
                    northChair.enable()
                return
        elif (not (state)):
            return
        if (id == nTubeEntry.id):
            print 'entered team 1 tube, run behavior'
            nTubeEntry.disable()
            avatar.avatar.runBehaviorSetNotify(nTubeMulti.value, self.key, 0)
        if (id == sTubeEntry.id):
            print 'entered team 2 tube, run behavior'
            sTubeEntry.disable()
            avatar.avatar.runBehaviorSetNotify(sTubeMulti.value, self.key, 0)
        if (avatar != PtGetLocalAvatar()):
            print 'not activated by me'
            return
        if (id == upButtonS.id):
            print 'up button south'
            if (southState == ptClimbingWallMsgState.kSouthSelect):
                print 'correct state, blocker count limit ',
                print BlockerCountLimit
                if (BlockerCountLimit < 20):
                    self.ChangeBlockerCount((BlockerCountLimit + 1))
                    sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='up')
                    return
                else:
                    print 'somehow think blocker count limit greater than 20?'
            sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == dnButtonS.id):
            print 'down button south'
            if (southState == ptClimbingWallMsgState.kSouthSelect):
                if (BlockerCountLimit > 0):
                    self.ChangeBlockerCount((BlockerCountLimit - 1))
                    sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='down')
                    return
            sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == fiveBtnS.id):
            print 'five button south'
            if (southState == ptClimbingWallMsgState.kSouthSelect):
                self.ChangeBlockerCount(5)
                sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='up')
                return
            sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == tenBtnS.id):
            print 'ten button south'
            if (southState == ptClimbingWallMsgState.kSouthSelect):
                self.ChangeBlockerCount(10)
                sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='up')
                return
            sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == fifteenBtnS.id):
            print 'fifteen button south'
            if (southState == ptClimbingWallMsgState.kSouthSelect):
                self.ChangeBlockerCount(15)
                sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='up')
                return
            sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == readyButtonS.id):
            print 'ready button south'
            if (southState == ptClimbingWallMsgState.kSouthSelect):
                self.ChangeGameState(ptClimbingWallMsgState.kSouthReady)
                sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='select')
                if (northState == ptClimbingWallMsgState.kNorthSelect):
                    self.ChangeGameState(ptClimbingWallMsgState.kNorthReady)
                    nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='select')
            else:
                sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == goButtonS.id):
            print 'picked s go button'
            if (southState == ptClimbingWallMsgState.kSouthSit):
                print 'set index to kSouthSelect'
                self.ZeroBlockerCount()
                self.ChangeGameState(ptClimbingWallMsgState.kSouthSelect)
                sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='main')
                if ((northState == ptClimbingWallMsgState.kWaiting) or ((northState == ptClimbingWallMsgState.kNorthSit) or ((northState == ptClimbingWallMsgState.kNorthWin) or (northState == ptClimbingWallMsgState.kNorthQuit)))):
                    print 'force north chair to keep up'
                    self.ChangeGameState(ptClimbingWallMsgState.kNorthSelect)
                    nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='main')
            elif (southState == ptClimbingWallMsgState.kSouthReady):
                print 'check to see if you\'ve used all your wall blockers'
                numSelected = SouthCount
                maxSelections = BlockerCountLimit
                if (numSelected < maxSelections):
                    sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
                else:
                    self.ChangeGameState(ptClimbingWallMsgState.kSouthPlayerEntry)
                    sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='gameStart')
            else:
                sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == upButtonN.id):
            print 'up button north'
            if (northState == ptClimbingWallMsgState.kNorthSelect):
                if (BlockerCountLimit < 20):
                    self.ChangeBlockerCount(BlockerCountLimit + 1)
                    nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='up')
                    return
            nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == dnButtonN.id):
            print 'down button north'
            if (northState == ptClimbingWallMsgState.kNorthSelect):
                if (BlockerCountLimit > 0):
                    self.ChangeBlockerCount(BlockerCountLimit - 1)
                    nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='down')
                    return
            nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == fiveBtnN.id):
            print 'five button north'
            if (northState == ptClimbingWallMsgState.kNorthSelect):
                self.ChangeBlockerCount(5)
                nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='up')
                return
            nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == tenBtnN.id):
            print 'ten button north'
            if (northState == ptClimbingWallMsgState.kNorthSelect):
                self.ChangeBlockerCount(10)
                nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='up')
                return
            nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == fifteenBtnN.id):
            print 'fifteen button north'
            if (northState == ptClimbingWallMsgState.kNorthSelect):
                self.ChangeBlockerCount(15)
                nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='up')
                return
            nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == readyButtonN.id):
            print 'ready button north'
            if (northState == ptClimbingWallMsgState.kNorthSelect):
                self.ChangeGameState(ptClimbingWallMsgState.kNorthReady)
                nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='select')
                if (southState == ptClimbingWallMsgState.kSouthSelect):
                    self.ChangeGameState(ptClimbingWallMsgState.kSouthReady)
                    sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='select')
                    print 'force south chair to keep up'
            else:
                nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        elif (id == goButtonN.id):
            print 'picked n go button'
            if (northState == ptClimbingWallMsgState.kNorthSit):
                print 'set index to kNorthSelect'
                self.ChangeGameState(ptClimbingWallMsgState.kNorthSelect)
                nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='main')
                if ((southState == ptClimbingWallMsgState.kWaiting) or ((southState == ptClimbingWallMsgState.kSouthSit) or ((southState == ptClimbingWallMsgState.kSouthWin) or (southState == ptClimbingWallMsgState.kSouthQuit)))): # corrected: this test used two times kSouthWin, and never kSouthQuit.... mauvais perdant !
                    self.ChangeGameState(ptClimbingWallMsgState.kSouthSelect)
                    sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='main')
                    print 'force south chair to keep up'
            elif (northState == ptClimbingWallMsgState.kNorthReady):
                print 'check to see if you\'ve used all your wall blockers'
                numSelected = NorthCount
                maxSelections = BlockerCountLimit
                if (numSelected < maxSelections):
                    nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
                else:
                    self.ChangeGameState(ptClimbingWallMsgState.kNorthPlayerEntry)
                    nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='gameStart')
            else:
                nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
            return
        for event in events:
            if ((event[0] == kPickedEvent) and (event[1] == 1)):
                panelPicked = event[3]
                objName = panelPicked.getName()
                print 'player picked blocker named ',
                print objName
                north = 0
                try:
                    index = northPanel.value.index(panelPicked)
                    north = 1
                except:
                    try:
                        index = southPanel.value.index(panelPicked)
                    except:
                        print 'no wall blocker found'
                        return
                if north:
                    if (northState != ptClimbingWallMsgState.kNorthReady):
                        print 'no blocker picking for you!'
                        nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
                        return
                    numSelected = NorthCount
                    print 'numSelected = ',
                    print numSelected
                    maxSelections = BlockerCountLimit
                    if (self.LookupIndex(index, true) == 0):
                        if (numSelected == maxSelections):
                            print 'you\'ve picked all you can'
                            nPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
                            return
                        self.ChangeBlockerState(true, index, true)
                    else:
                        numSelected = (numSelected - 1)
                        if (numSelected == -1):
                            print 'what?!?'
                            return
                        self.ChangeBlockerState(false, index, true)
                else:
                    if (southState != ptClimbingWallMsgState.kSouthReady):
                        print 'no blocker picking for you!'
                        sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
                        return
                    numSelected = SouthCount
                    print 'numSelected = ',
                    print numSelected
                    maxSelections = BlockerCountLimit
                    if (self.LookupIndex(index, false) == 0):
                        if (numSelected == maxSelections):
                            print 'you\'ve picked all you can'
                            sPanelSound.run(self.key, avatar=PtGetLocalAvatar(), state='denied')
                            return
                        self.ChangeBlockerState(true, index, false)
                    else:
                        numSelected = (numSelected - 1)
                        if (numSelected == -1):
                            print 'what?!?'
                            return
                        self.ChangeBlockerState(false, index, false)


glue_cl = None
glue_inst = None
glue_params = None
glue_paramKeys = None
try:
    x = glue_verbose
except NameError:
    glue_verbose = 0

def glue_getClass():
    global glue_cl
    if (glue_cl == None):
        try:
            cl = eval(glue_name)
            if issubclass(cl, ptModifier):
                glue_cl = cl
            elif glue_verbose:
                print ('Class %s is not derived from modifier' % cl.__name__)
        except NameError:
            if glue_verbose:
                try:
                    print ('Could not find class %s' % glue_name)
                except NameError:
                    print 'Filename/classname not set!'
    return glue_cl


def glue_getInst():
    global glue_inst
    if (type(glue_inst) == type(None)):
        cl = glue_getClass()
        if (cl != None):
            glue_inst = cl()
    return glue_inst


def glue_delInst():
    global glue_inst
    global glue_cl
    global glue_params
    global glue_paramKeys
    if (type(glue_inst) != type(None)):
        del glue_inst
    glue_cl = None
    glue_params = None
    glue_paramKeys = None


def glue_getVersion():
    inst = glue_getInst()
    ver = inst.version
    glue_delInst()
    return ver


def glue_getParamDict():
    global glue_params
    global glue_paramKeys
    if (type(glue_params) == type(None)):
        glue_params = {}
        gd = globals()
        for obj in gd.values():
            if isinstance(obj, ptAttribute):
                if glue_params.has_key(obj.id):
                    if glue_verbose:
                        print 'WARNING: Duplicate attribute ids!'
                        print ('%s has id %d which is already defined in %s' % (obj.name, obj.id, glue_params[obj.id].name))
                else:
                    glue_params[obj.id] = obj
        glue_paramKeys = glue_params.keys()
        glue_paramKeys.sort()
        glue_paramKeys.reverse()
    return glue_params


def glue_getClassName():
    cl = glue_getClass()
    if (cl != None):
        return cl.__name__
    if glue_verbose:
        print ('Class not found in %s.py' % glue_name)
    return None


def glue_getBlockID():
    inst = glue_getInst()
    if (inst != None):
        return inst.id
    if glue_verbose:
        print ('Instance could not be created in %s.py' % glue_name)
    return None


def glue_getNumParams():
    pd = glue_getParamDict()
    if (pd != None):
        return len(pd)
    if glue_verbose:
        print ('No attributes found in %s.py' % glue_name)
    return 0


def glue_getParam(number):
    global glue_paramKeys
    pd = glue_getParamDict()
    if (pd != None):
        if (type(glue_paramKeys) == type([])):
            if ((number >= 0) and (number < len(glue_paramKeys))):
                return pd[glue_paramKeys[number]].getdef()
            else:
                print ('glue_getParam: Error! %d out of range of attribute list' % number)
        else:
            pl = pd.values()
            if ((number >= 0) and (number < len(pl))):
                return pl[number].getdef()
            elif glue_verbose:
                print ('glue_getParam: Error! %d out of range of attribute list' % number)
    if glue_verbose:
        print 'GLUE: Attribute list error'
    return None


def glue_setParam(id, value):
    pd = glue_getParamDict()
    if (pd != None):
        if pd.has_key(id):
            try:
                pd[id].__setvalue__(value)
            except AttributeError:
                if isinstance(pd[id], ptAttributeList):
                    try:
                        if (type(pd[id].value) != type([])):
                            pd[id].value = []
                    except AttributeError:
                        pd[id].value = []
                    pd[id].value.append(value)
                else:
                    pd[id].value = value
        elif glue_verbose:
            print 'setParam: can\'t find id=',
            print id
    else:
        print 'setParma: Something terribly has gone wrong. Head for the cover.'


def glue_isNamedAttribute(id):
    pd = glue_getParamDict()
    if (pd != None):
        try:
            if isinstance(pd[id], ptAttribNamedActivator):
                return 1
            if isinstance(pd[id], ptAttribNamedResponder):
                return 2
        except KeyError:
            if glue_verbose:
                print ('Could not find id=%d attribute' % id)
    return 0


def glue_isMultiModifier():
    inst = glue_getInst()
    if isinstance(inst, ptMultiModifier):
        return 1
    return 0



